#! /usr/bin/env python3
#
# Start the restful server.

from opencog.web.api.apimain import RESTAPI
from opencog.atomspace import AtomSpace, types
from opencog.utilities import initialize_opencog
from opencog.type_constructors import *
from opencog.scheme_wrapper import scheme_eval_as

# Endpoint configuration
# To allow public access, set to 0.0.0.0; for local access, set to 127.0.0.1
IP_ADDRESS = '0.0.0.0'
PORT = 5000

atomspace = AtomSpace()
#atomspace = scheme_eval_as('(use-modules (opencog) (opencog python)) (cog-atomspace)')
#atomspace = scheme_eval_as("""
#  (and (use-modules (opencog) (opencog python)) (use-modules (opencog exec)) (use-modules (opencog persist)) 
#      (use-modules (opencog cogserver)) (use-modules (opencog persist-cog)) (cogserver-open "cog://10.0.0.233/") (load-atomspace))""")

initialize_opencog(atomspace)

Link(
    ConceptNode("Test Concept"),
    ConceptNode("another one")
)

api = RESTAPI(atomspace)
api.run(host=IP_ADDRESS, port=PORT)
